<?php

class ControllerExtensionApiMakeCommerce extends Controller {

    /**
     * Adds order's history.
     *
     * @return void                 
     */
    public function history() 
    {
        $this->load->language('api/order');

        $json = array();

        // Add keys for missing post vars
        $keys = array(
            'order_status_id',
            'notify',
            'override',
            'comment'
        );

        foreach ($keys as $key)
            if ( ! isset($this->request->post[$key]))
                $this->request->post[$key] = '';

        $this->load->model('checkout/order');

        if (isset($this->request->get['order_id']))
            $order_id = $this->request->get['order_id'];
        else
            $order_id = 0;

        $order_info = $this->model_checkout_order->getOrder($order_id);

        if ($order_info) {
            $this->model_checkout_order->addOrderHistory($order_id, $this->request->post['order_status_id'], $this->request->post['comment'], $this->request->post['notify'], $this->request->post['override']);

            $json['success'] = $this->language->get('text_success');
        } else {
            $json['error'] = $this->language->get('error_not_found');
        }

        if (isset($this->request->server['HTTP_ORIGIN'])) {
            $this->response->addHeader('Access-Control-Allow-Origin: ' . $this->request->server['HTTP_ORIGIN']);
            $this->response->addHeader('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');
            $this->response->addHeader('Access-Control-Max-Age: 1000');
            $this->response->addHeader('Access-Control-Allow-Headers: Content-Type, Authorization, X-Requested-With');
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

}
