<?php

class ModelExtensionModuleMakeCommerceSco extends Model {
    // private $handle;


    /*
    *   Format the link to work with ajax requests
    */
    // public function ajax($link){
    //     return str_replace('&amp;', '&', $link);
    // }

    /*
    *   Create backup copy of active cart
    */
    public function setCartCopy( $cart = array() ) {
        $cartArray = array();
        $this->db->query("INSERT INTO `" . DB_PREFIX . "make_commerce_sco_carts` SET
                   `created`  = " . time() . ",
                   `modified` = " . time() . ",
                   `status`   = 0,
                   `content`  = '" . json_encode( $cart, JSON_UNESCAPED_UNICODE ) . "'
        ");
        return $this->db->getLastId();
    }

    /*
    *   Update backup data for active cart
    */
    public function updateCartId( $id, $cartId) {
        $this->db->query("UPDATE `" . DB_PREFIX . "make_commerce_sco_carts` SET `cart_id` = '" . $cartId . "', `modified` = " .time(). " where `id` = " . $id);
    }

    /*
    *   get session_id using cart_id
    */
    public function getCartSessionId( $cartId) {
        $query = $this->db->query("SELECT * from `" . DB_PREFIX . "make_commerce_sco_carts` WHERE `cart_id` = '" . $cartId ."'");
        $content = json_decode($query->row["content"], TRUE);
        $query = $this->db->query("SELECT distinct session_id from `" . DB_PREFIX . "cart` WHERE `cart_id` = " . $content[0]["cart_id"] . " LIMIT 1" );
        if (isset($query->row["session_id"])) return $query->row["session_id"]; else return false;
    }


    /*
    *   Get distinct list of enabled countries
    */
    public function getGeoZoneCountries() {
        $query = $this->db->query("select `iso_code_2`, `country_id`, 0 as zone_id from  `" . DB_PREFIX . "country` where `country_id` in (select distinct `country_id` from `" . DB_PREFIX . "zone_to_geo_zone`)");
        $enabled_countries = array();
        foreach ($query->rows as $country) {
            $enabled_countries[] = $country;
        }
        return $enabled_countries;
    }

    /*
    *   Get original cart's backup as it was when sco was initiated for comparision
    */
    public function getCartCopy( $cartId ) {
        $query = $this->db->query("SELECT * from `" . DB_PREFIX . "make_commerce_sco_carts` WHERE `cart_id` = '" . $cartId ."'");
        $content = json_decode($query->row["content"], TRUE);
        if (isset($content)) return $content; else return false;
    }

    /*
    *   delete original cart's backup
    */
    public function deleteCartCopy( $cartId ) {
        $query = $this->db->query("delete from `" . DB_PREFIX . "make_commerce_sco_carts` WHERE `cart_id` = '" . $cartId ."'");
        return true;
    }

    public function getShipmentMethods( $countryCode = "") {
        $shipmentMethods = array();
        $this->load->model('account/address');
        $this->load->model('setting/extension');
        $results = $this->model_setting_extension->getExtensions('shipping');
        foreach ( $this->getGeoZoneCountries() as $country ) {
            foreach ($results as $key =>$result) {
                if ($countryCode <> "") if ($country["iso_code_2"] != $countryCode) continue;
                if ($this->config->get($result['type'] . '_' . $result['code'] . '_status')) {
                    $this->load->model('extension/shipping/' . $result['code']);
                    $quote = $this->{'model_extension_shipping_' . $result['code']}->getQuote($country);
                    if (isset($quote["code"])) {
                        $method_data = $this->convertShippingMethod( $quote );
                        $method_data["code"] = $result["code"];
                        $isSet = 0;
                        foreach ($shipmentMethods as $methodKey => $method) {
                            if (isset($method["carrier"])) {
                                if ( ($method["methodId"] == $method_data["methodId"]) && ($method["amount"]   == $method_data["amount"]) ) {
                                    $shipmentMethods[$methodKey]["countries"][] = $country["iso_code_2"];
                                    $isSet = 1;
                                }
                            }
                        }
                        if ($isSet == 0) {
                            $method_data["countries"][] = $country["iso_code_2"];
                            $shipmentMethods[] = $method_data;
                        }
                    }
                }
            }
        }
        return $shipmentMethods;
    }

    /*
    *   Get list of enabled shipping methods
    */
    public function convertShippingMethod( $method ) {
        $ret = array();
        $method_code = explode ("_",$method["code"]);
        switch ($method_code[0]) {
            case "flat":
                $ret["name"] = $method["quote"][$method["code"]]["title"];
                $ret["methodId"] = "flat_rate:".$method["sort_order"];
                $ret["type"] = "COU";
                break;
            case "pickup":
                $ret["name"] = $method["quote"][$method["code"]]["title"];
                $ret["methodId"] = "local_pickup:".$method["sort_order"];
                $ret["type"] = "OTH";
                break;
            case "omniva":
                $ret["carrier"] = "OMNIVA";
                if ($method_code[1]=="parcel") {
                    $ret["name"] = "Omniva pakiautomaat"; // Tõlked!
                    $ret["type"] = "APT";
                    $ret["methodId"] = "parcelmachine_omniva:".$method["sort_order"];
                }
                if ($method_code[1]=="courier") {
                    $ret["name"] = "Omniva kuller"; // Tõlked!
                    $ret["type"] = "COU";
                    $ret["methodId"] = "courier_omniva:".$method["sort_order"];
                }
                break;
            default:
                $ret["name"] = $method["quote"][$method["code"]]["title"];
                $ret["methodId"] = $method["code"].":".$method["sort_order"];
                $ret["type"] = "COU";
        }
        $ret["codename"]= $method["code"];
        $ret["method"]["code"] = $method["quote"][$method["code"]]["code"];
        $ret["method"]["title"] = $method["quote"][$method["code"]]["title"];
        $ret["method"]["cost"] = $method["quote"][$method["code"]]["cost"];
        $ret["method"]["tax_class_id"] = $method["quote"][$method["code"]]["tax_class_id"];
        $ret["amount"] = round($ret["method"]["cost"] + $this->cart->tax->getTax($ret["method"]["cost"], $ret["method"]["tax_class_id"]),2);
        $ret["method"]["text"] = $method["quote"][$method["code"]]["text"];
        if (strlen($ret["method"]["title"])<2) $ret["method"]["title"] = $ret["name"];
        // $ret["amount"] = filter_var( $method["quote"][$method["code"]]["text"], FILTER_SANITIZE_NUMBER_FLOAT, FILTER_FLAG_ALLOW_FRACTION | FILTER_FLAG_ALLOW_THOUSAND);
        return $ret;
    }

    /*
     *   Get data for specified country
     */
    public function getCountryData( $countryCode ) {
        $sql = "select `country_id`, `name`, `iso_code_2`, `iso_code_3` from  `" . DB_PREFIX . "country` where `";
        if (strlen($countryCode)==2) $sql.='iso_code_2';
        else if (strlen($countryCode)==3) $sql.='iso_code_3';
        else $sql.='name';
        $query = $this->db->query($sql."`='".$countryCode."'");
        $res["country_id"]=$query->row["country_id"];
        $res["name"]=$query->row["name"];
        $res["iso_code_2"]=$query->row["iso_code_2"];
        $res["iso_code_3"]=$query->row["iso_code_3"];
        return $res;
    }

    /*
     *   Get data for specified county
     */
    public function getCountyData( $countyName ) {
        $a = array('À', 'Á', 'Â', 'Ã', 'Ä', 'Å', 'Æ', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í', 'Î', 'Ï', 'Ð', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', 'Ø', 'Ù', 'Ú', 'Û', 'Ü', 'Ý', 'ß', 'à', 'á', 'â', 'ã', 'ä', 'å', 'æ', 'ç', 'è', 'é', 'ê', 'ë', 'ì', 'í', 'î', 'ï', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', 'ø', 'ù', 'ú', 'û', 'ü', 'ý', 'ÿ', 'Ā', 'ā', 'Ă', 'ă', 'Ą', 'ą', 'Ć', 'ć', 'Ĉ', 'ĉ', 'Ċ', 'ċ', 'Č', 'č', 'Ď', 'ď', 'Đ', 'đ', 'Ē', 'ē', 'Ĕ', 'ĕ', 'Ė', 'ė', 'Ę', 'ę', 'Ě', 'ě', 'Ĝ', 'ĝ', 'Ğ', 'ğ', 'Ġ', 'ġ', 'Ģ', 'ģ', 'Ĥ', 'ĥ', 'Ħ', 'ħ', 'Ĩ', 'ĩ', 'Ī', 'ī', 'Ĭ', 'ĭ', 'Į', 'į', 'İ', 'ı', 'Ĳ', 'ĳ', 'Ĵ', 'ĵ', 'Ķ', 'ķ', 'Ĺ', 'ĺ', 'Ļ', 'ļ', 'Ľ', 'ľ', 'Ŀ', 'ŀ', 'Ł', 'ł', 'Ń', 'ń', 'Ņ', 'ņ', 'Ň', 'ň', 'ŉ', 'Ō', 'ō', 'Ŏ', 'ŏ', 'Ő', 'ő', 'Œ', 'œ', 'Ŕ', 'ŕ', 'Ŗ', 'ŗ', 'Ř', 'ř', 'Ś', 'ś', 'Ŝ', 'ŝ', 'Ş', 'ş', 'Š', 'š', 'Ţ', 'ţ', 'Ť', 'ť', 'Ŧ', 'ŧ', 'Ũ', 'ũ', 'Ū', 'ū', 'Ŭ', 'ŭ', 'Ů', 'ů', 'Ű', 'ű', 'Ų', 'ų', 'Ŵ', 'ŵ', 'Ŷ', 'ŷ', 'Ÿ', 'Ź', 'ź', 'Ż', 'ż', 'Ž', 'ž', 'ſ', 'ƒ', 'Ơ', 'ơ', 'Ư', 'ư', 'Ǎ', 'ǎ', 'Ǐ', 'ǐ', 'Ǒ', 'ǒ', 'Ǔ', 'ǔ', 'Ǖ', 'ǖ', 'Ǘ', 'ǘ', 'Ǚ', 'ǚ', 'Ǜ', 'ǜ', 'Ǻ', 'ǻ', 'Ǽ', 'ǽ', 'Ǿ', 'ǿ');
        $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
        $query = $this->db->query("select * from  `" . DB_PREFIX . "zone` where SUBSTRING_INDEX(`name` , ' ', 1) = '".str_replace($a, $b, $countyName)."'");
        return $query->row;
    }

   /*
    *    Compile order data according to mk_cart_to_order request
    */
    public function makeOrder ( $orderInfo ) {
        $cartId          = $orderInfo->cartId;
        $customer        = $orderInfo->customer;
        $shipmentAddress = $orderInfo->shipmentAddress;
        if (isset($orderInfo->invoiceAddress)) $invoiceAddress = $orderInfo->invoiceAddress;

        $shipmentMethod  = $orderInfo->shipmentMethod;
        $comment = "";
        unset($selectedMethod);
        $shipmentMethods = $this->getShipmentMethods($shipmentAddress->country);
        foreach ($shipmentMethods as $method ) {
            if ( $method['methodId'] == $shipmentMethod->methodId )
                $selectedMethod = $method;
        }
        if ($selectedMethod["type"]=="APT") {
            $name = "";
            $code   = str_replace ( "_by_make_commerce" , "" , $selectedMethod["code"]);
            if ($code == 'omniva_parcel') {
                $this->load->model('extension/shipping/omniva_parcel_by_make_commerce');
                $machines = $this->model_extension_shipping_omniva_parcel_by_make_commerce->getShippingParcels('omniva');
            }
            if ($code == 'omniva_parcel') {
                $code .= ":" . $orderInfo->shipmentAddress->destinationId;
                foreach ($machines as $countryKey => $countryValue) {
                    foreach ($countryValue  as $cityKey => $cityValue) {
                        foreach ($cityValue as $key => $machine) {
                            if ($machine["parcel_id"] == $orderInfo->shipmentAddress->destinationId) $name = $selectedMethod["name"]." ".$machine["name"];
                        }
                    }
                }
            }
        } else { // all other delivery methods, special handler for by_make_commerce methods
            $code   = $selectedMethod["code"] . "." . str_replace ( "_by_make_commerce" , "" , $selectedMethod["code"]);
            $name   = $selectedMethod["name"];
        }
        $this->session->data["shipping_method"] = $selectedMethod["method"];

        // compare original cart to current - should be unchanged
        $originalCart = $this->getCartCopy($cartId);
        $currentCart  = $this->cart->getProducts();

        if( $originalCart == $currentCart ) { // cart hasn't changed, proceed
            // Convert cart to order
            $this->deleteCartCopy( $cartId ); // delete cart's backup copy
            $this->session->data['payment_method'] = 'make_commerce';

            $error = 0;

            if ($this->cart->hasShipping()) {
                if (!isset($this->session->data['shipping_address'])) 
                    if (isset($shipmentAddress->country)) {
                        $countryData = $this->getCountryData($shipmentAddress->country);
                        $this->session->data["shipping_address"]["country"] = $countryData["name"];
                    } else $error += 2;
                if (!isset($this->session->data['shipping_method']))  $error += 4;
            } else $error +=1;

            if ((!$this->cart->hasProducts() && empty($this->session->data['vouchers'])) || (!$this->cart->hasStock() && !$this->config->get('config_stock_checkout'))) $error += 8;

            foreach ($currentCart as $product) {
                $product_total = 0;
                foreach ($currentCart as $product_2) {
                    if ($product_2['product_id'] == $product['product_id']) {
                        $product_total += $product_2['quantity'];
                    }
                }
                if ($product['minimum'] > $product_total) {
                    $error += 16;
                    break;
                }
            }

            if (!$error) {
                $order_data = array();

                $totals = array();
                $taxes = $this->cart->getTaxes();
                $total = 0;

                // Because __call can not keep var references so we put them into an array.
                $total_data = array(
                    'totals' => &$totals,
                    'taxes'  => &$taxes,
                    'total'  => &$total
                );

                $this->load->model('setting/extension');
                $sort_order = array();

                $results = $this->model_setting_extension->getExtensions('total');

                foreach ($results as $key => $value) {
                    $sort_order[$key] = $this->config->get('total_' . $value['code'] . '_sort_order');
                }

                array_multisort($sort_order, SORT_ASC, $results);

                foreach ($results as $result) {
                    if ($this->config->get('total_' . $result['code'] . '_status')) {
                        $this->load->model('extension/total/' . $result['code']);
                        // We have to put the totals in an array so that they pass by reference.
                        $this->{'model_extension_total_' . $result['code']}->getTotal($total_data);
                    }
                }

                $sort_order = array();

                foreach ($totals as $key => $value) {
                    $sort_order[$key] = $value['sort_order'];
                }

                array_multisort($sort_order, SORT_ASC, $totals);

                $order_data['totals'] = $totals;

                $this->load->language('checkout/checkout');

                $order_data['invoice_prefix'] = $this->config->get('config_invoice_prefix');
                $order_data['store_id'] = $this->config->get('config_store_id');
                $order_data['store_name'] = $this->config->get('config_name');

                if ($order_data['store_id']) {
                    $order_data['store_url'] = $this->config->get('config_url');
                } else {
                    if ($this->request->server['HTTPS']) {
                        $order_data['store_url'] = HTTPS_SERVER;
                    } else {
                        $order_data['store_url'] = HTTP_SERVER;
                    }
                }

                $this->load->model('account/customer');
                // customer data
                if ($this->customer->isLogged()) {
                    $customer_info = $this->model_account_customer->getCustomer($this->customer->getId());
                    $order_data['customer_id'] = $this->customer->getId();
                    $order_data['customer_group_id'] = $customer_info['customer_group_id'];
                    $order_data['firstname'] = $orderInfo->customer->firstname;
                    $order_data['lastname'] =  $orderInfo->customer->lastname;
                    $order_data['email'] = $orderInfo->customer->email;
                    $order_data['telephone'] = $orderInfo->customer->phone;
                    $order_data['custom_field'] = json_decode($customer_info['custom_field'], true);
                    $this->session->data['customer']['customer_id'] = $order_data['customer_id'];
                    $this->session->data['customer']['customer_group_id'] = $order_data['customer_group_id'];
                    $this->session->data['customer']['firstname'] = $order_data['firstname'];
                    $this->session->data['customer']['lastname'] = $order_data['lastname'];
                    $this->session->data['customer']['email'] = $order_data['email'];
                    $this->session->data['customer']['telephone'] = $order_data['telephone'];
                } else {
                    // error_log("guest not set");
                    $order_data['customer_id'] = 0;
                    $order_data['customer_group_id'] = $this->customer->getGroupId();
                    $order_data['firstname'] = $orderInfo->customer->firstname;
                    $order_data['lastname'] = $orderInfo->customer->lastname;
                    $order_data['email'] = $orderInfo->customer->email;
                    $order_data['telephone'] = $orderInfo->customer->phone;
                    $this->session->data['guest']['firstname'] = $orderInfo->customer->firstname;
                    $this->session->data['guest']['lastname'] = $orderInfo->customer->lastname;
                    $this->session->data['guest']['email'] = $orderInfo->customer->email;
                    $this->session->data['guest']['telephone'] = $orderInfo->customer->phone;
                    if (isset($this->session->data['guest']['custom_field'])) $order_data['custom_field'] = $this->session->data['guest']['custom_field']; else $this->session->data['guest']['custom_field'] = $order_data['custom_field'] ="";
                    // if(!isset($order_data['customer_id'])) $order_data['customer_id'] = 0;
                }
                // invoice (payment) address
                if ( isset($orderInfo->invoiceAddress)) {
                    $this->session->data['payment_address']['country_id'] =  $this->config->get('config_country_id');
                    $this->session->data['payment_address']['zone_id'] = $this->config->get('config_zone_id');
                    if (isset($orderInfo->invoiceAddress->country))  {
                        $countryData = $this->getCountryData($orderInfo->invoiceAddress->country);
                        $this->session->data['payment_address']['country'] = $countryData["name"];
                        $order_data["payment_country"] = $countryData["name"];
                        $this->session->data['payment_address']['country_id'] = $countryData["country_id"];
                        $order_data["payment_country_id"] = $countryData["country_id"];
                    } else { $order_data["payment_country"] = ""; $order_data["payment_country_id"] = 0; }
                    if (isset($orderInfo->invoiceAddress->county))  {
                        $countyData = $this->getCountyData($orderInfo->invoiceAddress->county);
                        $this->session->data['payment_address']['zone'] = $countyData["name"];
                        $order_data["payment_zone"] = $countyData["name"];
                        $this->session->data['payment_address']['zone_id'] = $countyData["zone_id"];
                        $order_data["payment_zone_id"] = $countyData["zone_id"];
                    } else { $order_data["payment_zone"] = ""; $order_data["payment_zone_id"] = 0; }
                    if (isset($orderInfo->invoiceAddress->street1))    { $this->session->data['payment_address']['address_1'] = $order_data["payment_address_1"] = $orderInfo->invoiceAddress->street1; } else { $this->session->data['payment_address']['address_1']   = $order_data["payment_address_1"] = ""; }
                    if (isset($orderInfo->invoiceAddress->street2))    { $this->session->data['payment_address']['address_2'] = $order_data["payment_address_2"] = $orderInfo->invoiceAddress->street2; } else { $this->session->data['payment_address']['address_2']   = $order_data["payment_address_2"] = ""; }
                    if (isset($orderInfo->invoiceAddress->postalCode)) { $this->session->data['payment_address']['postcode']  = $order_data["payment_postcode"]  = $orderInfo->invoiceAddress->postalCode; } else { $this->session->data['payment_address']['postcode'] = $order_data["payment_postcode"]  = ""; }
                    if (isset($orderInfo->invoiceAddress->city))       { $this->session->data['payment_address']['city']      = $order_data["payment_city"]      = $orderInfo->invoiceAddress->city; } else { $this->session->data['payment_address']['city']           = $order_data["payment_city"]      = ""; }
                    if (isset($orderInfo->invoiceAddress->firstname))  { $this->session->data['payment_address']['firstname'] = $order_data["payment_firstname"] = $orderInfo->invoiceAddress->firstname; } else { $this->session->data['payment_address']['firstname'] = $order_data["payment_firstname"] = ""; }
                    if (isset($orderInfo->invoiceAddress->lastname))   { $this->session->data['payment_address']['lastname']  = $order_data["payment_lastname"]  = $orderInfo->invoiceAddress->lastname; } else { $this->session->data['payment_address']['lastname']   = $order_data["payment_lastname"]  = ""; }
                    if (isset($orderInfo->invoiceAddress->legalName))  { $this->session->data['payment_address']['company']   = $order_data["payment_company"]   = $orderInfo->invoiceAddress->legalName; } else { $this->session->data['payment_address']['company']   = $order_data["payment_company"]   = ""; }
                    $order_data["payment_address_format"] = "";
                    $this->session->data["payment_address"]["custom_field"] = ""; $order_data["payment_custom_field"] = "";
                    if (isset($orderInfo->invoiceAddress->registryCode)) { $this->session->data['payment_address']['custom_field'] .= "Reg. No: ".$orderInfo->invoiceAddress->registryCode; }
                    if (isset($orderInfo->invoiceAddress->vatNum))       { $this->session->data['payment_address']['custom_field'] .= "\nVAT No: ".$orderInfo->invoiceAddress->vatNum; }
                    $order_data['payment_custom_field'] =
                        (isset($this->session->data['payment_address']['custom_field']) ? $this->session->data['payment_address']['custom_field'] : array());
                } else {  // no separate invoice address given
                    $this->session->data['payment_address']['country_id'] = $this->config->get('config_country_id');
                    $this->session->data['payment_address']['zone_id'] = $this->config->get('config_zone_id');
                    if (isset($orderInfo->shipmentAddress->country))  {
                        $countryData = $this->getCountryData($orderInfo->shipmentAddress->country);
                        $this->session->data['payment_address']['country'] = $order_data["payment_country"] = $countryData["name"];
                        $this->session->data['payment_address']['country_id'] = $order_data["payment_country_id"] = $countryData["country_id"];
                    } else { $this->session->data['payment_address']['country'] = $order_data["payment_country"] = ""; $this->session->data['payment_address']['country_id'] = $order_data["payment_country_id"] = 0;}
                    if (isset($orderInfo->shipmentAddress->county))  {
                        $countyData = $this->getCountyData($orderInfo->shipmentAddress->county);
                        if (isset($countyData["name"])) $this->session->data['payment_address']['zone'] = $order_data["payment_zone"] = $countyData["name"]; else $this->session->data['payment_address']['zone'] = $order_data["payment_zone"] = "";
                        if (isset($countyData["zone_id"])) $this->session->data['payment_address']['zone_id'] = $order_data["payment_zone_id"] = $countyData["zone_id"]; else $this->session->data['payment_address']['zone_id'] = $order_data["payment_zone_id"] = 0;
                    } else { $this->session->data['payment_address']['zone'] = $order_data["payment_zone"] = ""; $this->session->data['payment_address']['zone_id'] = $order_data["payment_zone_id"] = 0; }
                    if (isset($orderInfo->shipmentAddress->street1))    { $this->session->data['payment_address']['address_1'] = $order_data["payment_address_1"] = $orderInfo->shipmentAddress->street1; }    else { $this->session->data['payment_address']['address_1'] = $order_data["payment_address_1"] = ""; }
                    if (isset($orderInfo->shipmentAddress->street2))    { $this->session->data['payment_address']['address_2'] = $order_data["payment_address_2"] = $orderInfo->shipmentAddress->street2; }    else { $this->session->data['payment_address']['address_2'] = $order_data["payment_address_2"] = ""; }
                    if (isset($orderInfo->shipmentAddress->postalCode)) { $this->session->data['payment_address']['postcode']  = $order_data["payment_postcode"]  = $orderInfo->shipmentAddress->postalCode; } else { $this->session->data['payment_address']['postcode']  = $order_data["payment_postcode"]  = ""; }
                    if (isset($orderInfo->shipmentAddress->city))       { $this->session->data['payment_address']['city']      = $order_data["payment_city"]      = $orderInfo->shipmentAddress->city; }       else { $this->session->data['payment_address']['city']      = $order_data["payment_city"]      = ""; }
                    if (isset($orderInfo->shipmentAddress->firstname))  { $this->session->data['payment_address']['firstname'] = $order_data["payment_firstname"] = $orderInfo->shipmentAddress->firstname; }  else { $this->session->data['payment_address']['firstname'] = $order_data["payment_firstname"] = ""; }
                    if (isset($orderInfo->shipmentAddress->lastname))   { $this->session->data['payment_address']['lastname']  = $order_data["payment_lastname"]  = $orderInfo->shipmentAddress->lastname; }   else { $this->session->data['payment_address']['lastname']  = $order_data["payment_lastname"]  = ""; }
                    if (isset($orderInfo->shipmentAddress->legalName))  { $this->session->data['payment_address']['company']   = $order_data["payment_company"]   = $orderInfo->shipmentAddress->legalName; }  else { $this->session->data['payment_address']['company']   = $order_data["payment_company"]   = ""; }
                    $order_data["payment_address_format"] = "";
                }

                if (isset($this->session->data['payment_method']['title'])) {
                    $order_data['payment_method'] = $this->session->data['payment_method']['title'];
                } else {
                    $order_data['payment_method'] = '';
                }

                if (isset($this->session->data['payment_method']['code'])) {
                    $order_data['payment_code'] = $this->session->data['payment_method']['code'];
                } else {
                    $order_data['payment_code'] = '';
                }
                $this->session->data['shipping_address']['country_id'] =  $this->config->get('config_country_id');
                $this->session->data['shipping_address']['zone_id'] = $this->config->get('config_zone_id');
                if ($this->cart->hasShipping()) {
                    if (isset($orderInfo->shipmentAddress->firstname)) { $order_data['shipping_firstname'] = $orderInfo->shipmentAddress->firstname;
                        $this->session->data['shipping_address']['firstname'] = $orderInfo->shipmentAddress->firstname;
                    } else { $this->session->data['shipping_address']['firstname'] = ""; $order_data['shipping_firstname'] = ""; }
                    if (isset($orderInfo->shipmentAddress->lastname)) { $order_data['shipping_lastname'] = $orderInfo->shipmentAddress->lastname;
                        $this->session->data['shipping_address']['lastname'] = $orderInfo->shipmentAddress->lastname;
                    } else {  $this->session->data['shipping_address']['lastname'] = ""; $order_data['shipping_lastname'] = ""; }
                    if (isset($orderInfo->invoiceAddress->legalName)) { $order_data['shipping_company'] = $orderInfo->invoiceAddress->legalName;
                        $this->session->data['shipping_address']['company'] = $orderInfo->invoiceAddress->legalName;
                    } else { $this->session->data['shipping_address']['company'] = ""; $order_data['shipping_company'] = ""; }
                    if (isset($orderInfo->shipmentAddress->street1)) { $order_data['shipping_address_1'] = $orderInfo->shipmentAddress->street1;
                        $this->session->data['shipping_address']['address_1'] = $orderInfo->shipmentAddress->street1;
                    } else { $this->session->data['shipping_address']['address_1'] = ""; $order_data['shipping_address_1'] = ""; }
                    if (isset($orderInfo->shipmentAddress->street2)) { $order_data['shipping_address_2'] = $orderInfo->shipmentAddress->street2;
                        $this->session->data['shipping_address']['address_2'] = $orderInfo->shipmentAddress->street2;
                    } else { $this->session->data['shipping_address']['address_2'] = ""; $order_data['shipping_address_2'] = ""; }
                    if (isset($orderInfo->shipmentAddress->city)) { $order_data['shipping_city'] = $orderInfo->shipmentAddress->city;
                        $this->session->data['shipping_address']['city'] = $orderInfo->shipmentAddress->city;
                    } else { $this->session->data['shipping_address']['city'] = ""; $order_data['shipping_city'] = ""; }
                    if (isset($orderInfo->shipmentAddress->postalCode)) { $order_data['shipping_postcode'] = $orderInfo->shipmentAddress->postalCode;
                        $this->session->data['shipping_address']['postcode'] = $orderInfo->shipmentAddress->postalCode;
                    } else { $this->session->data['shipping_address']['postcode'] = ""; $order_data['shipping_postcode'] = "";}
                    if (isset($orderInfo->shipmentAddress->country))  {
                        $countryData = $this->getCountryData($orderInfo->shipmentAddress->country);
                        if ($countryData["name"]<>"") {
                            $this->session->data['shipping_address']['country'] = $countryData["name"];
                            $order_data['shipping_country'] = $this->session->data['shipping_address']['country'];
                        } else $this->session->data['shipping_address']['country'] = $order_data['shipping_country'] = "";
                        if ($countryData["country_id"] <> "") {
                            $this->session->data['shipping_address']['country_id'] = $countryData["country_id"];
                            $order_data['shipping_country_id'] = $this->session->data['shipping_address']['country_id'];
                        } else $this->session->data['shipping_address']['country_id'] = $order_data['shipping_country_id'] = 0;
                    } else {
                        $this->session->data['shipping_address']['country'] = $order_data['shipping_country'] = ""; $this->session->data['shipping_address']['country_id'] = $order_data['shipping_country_id'] = 0;
                    }
                    if (isset($orderInfo->shipmentAddress->county))  {
                        $countyData = $this->getCountyData($orderInfo->shipmentAddress->county);
                        if (isset($countyData["name"])) {
                            $this->session->data['shipping_address']['zone'] = $countyData["name"];
                            $order_data['shipping_zone'] = $this->session->data['shipping_address']['zone'];
                        } else $order_data['shipping_zone'] = $this->session->data['shipping_address']['zone'] = "";
                        if (isset($countyData["zone_id"])) {
                            $this->session->data['shipping_address']['zone_id'] = $countyData["zone_id"];
                            $order_data['shipping_zone_id'] = $this->session->data['shipping_address']['zone_id'];
                        } else $order_data['shipping_zone_id'] = $this->session->data['shipping_address']['zone_id'] = 0;
                    } else {
                        $order_data['shipping_zone'] = ""; $this->session->data['shipping_address']['zone'] = ""; $order_data['shipping_zone_id'] = $this->session->data['shipping_address']['zone_id'] = 0;
                    }
                    if (isset($this->session->data['shipping_address']['address_format'])) $order_data['shipping_address_format'] = $this->session->data['shipping_address']['address_format']; else $order_data['shipping_address_format'] = "";
                    $order_data['shipping_custom_field'] = 
                            (isset($this->session->data['shipping_address']['custom_field']) ? $this->session->data['shipping_address']['custom_field'] : array());

                    if (isset($this->session->data['shipping_method']['title'])) {
                        $order_data['shipping_method'] = $name;
                    } else {
                        $order_data['shipping_method'] = '';
                    }

                    if (isset($this->session->data['shipping_method']['code'])) {
                            $order_data['shipping_code'] = $code;
                    } else {
                        $order_data['shipping_code'] = '';
                    }
                } else {
                    $order_data['shipping_zone'] = '';
                    $order_data['shipping_firstname'] = '';
                    $order_data['shipping_lastname'] = '';
                    $order_data['shipping_company'] = '';
                    $order_data['shipping_address_1'] = '';
                    $order_data['shipping_address_2'] = '';
                    $order_data['shipping_city'] = '';
                    $order_data['shipping_postcode'] = '';
                    $order_data['shipping_zone'] = '';
                    $order_data['shipping_zone_id'] = '';
                    $order_data['shipping_country'] = '';
                    $order_data['shipping_country_id'] = '';
                    $order_data['shipping_address_format'] = '';
                    $order_data['shipping_custom_field'] = array();
                    $order_data['shipping_method'] = '';
                    $order_data['shipping_code'] = '';
                }

                $order_data['products'] = array();

                foreach ($this->cart->getProducts() as $product) {
                    $option_data = array();
                    foreach ($product['option'] as $option) {
                        $option_data[] = array(
                            'product_option_id'       => $option['product_option_id'],
                            'product_option_value_id' => $option['product_option_value_id'],
                            'option_id'               => $option['option_id'],
                            'option_value_id'         => $option['option_value_id'],
                            'name'                    => $option['name'],
                            'value'                   => $option['value'],
                            'type'                    => $option['type']
                            );
                    }

                    $order_data['products'][] = array(
                        'product_id' => $product['product_id'],
                        'name'       => $product['name'],
                        'model'      => $product['model'],
                        'option'     => $option_data,
                        'download'   => $product['download'],
                        'quantity'   => $product['quantity'],
                        'subtract'   => $product['subtract'],
                        'price'      => $product['price'],
                        'total'      => $product['total'],
                        'tax'        => $this->tax->getTax($product['price'], $product['tax_class_id']),
                        'reward'     => $product['reward']
                        );
                }

                // Gift Voucher
                $order_data['vouchers'] = array();

                if (!empty($this->session->data['vouchers'])) {
                    foreach ($this->session->data['vouchers'] as $voucher) {
                        $order_data['vouchers'][] = array(
                            'description'      => $voucher['description'],
                            'code'             => token(10),
                            'to_name'          => $voucher['to_name'],
                            'to_email'         => $voucher['to_email'],
                            'from_name'        => $voucher['from_name'],
                            'from_email'       => $voucher['from_email'],
                            'voucher_theme_id' => $voucher['voucher_theme_id'],
                            'message'          => $voucher['message'],
                            'amount'           => $voucher['amount']
                            );
                    }
                }

                if ( isset($this->session->data['comment']))
                    $order_data['comment'] = $this->session->data['comment'];
                else
                    $this->session->data['comment'] = $order_data["comment"] = "";
                $order_data['total'] = $total_data['total'];

                if (isset($this->request->cookie['tracking'])) {
                    $order_data['tracking'] = $this->request->cookie['tracking'];

                    $subtotal = $this->cart->getSubTotal();

                    // Affiliate
                    $affiliate_info = $this->model_account_customer->getAffiliateByTracking($this->request->cookie['tracking']);

                    if ($affiliate_info) {
                        $order_data['affiliate_id'] = $affiliate_info['customer_id'];
                        $order_data['commission'] = ($subtotal / 100) * $affiliate_info['commission'];
                    } else {
                        $order_data['affiliate_id'] = 0;
                        $order_data['commission'] = 0;
                    }

                    // Marketing
                    $this->load->model('checkout/marketing');

                    $marketing_info = $this->model_checkout_marketing->getMarketingByCode($this->request->cookie['tracking']);

                    if ($marketing_info) {
                        $order_data['marketing_id'] = $marketing_info['marketing_id'];
                    } else {
                        $order_data['marketing_id'] = 0;
                    }
                } else {
                    $order_data['affiliate_id'] = 0;
                    $order_data['commission'] = 0;
                    $order_data['marketing_id'] = 0;
                    $order_data['tracking'] = '';
                }

                $order_data['language_id'] = $this->config->get('config_language_id');
                $order_data['currency_id'] = $this->currency->getId($this->session->data['currency']);
                $order_data['currency_code'] = $this->session->data['currency'];
                $order_data['currency_value'] = $this->currency->getValue($this->session->data['currency']);
                $order_data['ip'] = $this->request->server['REMOTE_ADDR'];

                if (!empty($this->request->server['HTTP_X_FORWARDED_FOR'])) {
                    $order_data['forwarded_ip'] = $this->request->server['HTTP_X_FORWARDED_FOR'];
                } elseif (!empty($this->request->server['HTTP_CLIENT_IP'])) {
                    $order_data['forwarded_ip'] = $this->request->server['HTTP_CLIENT_IP'];
                } else {
                    $order_data['forwarded_ip'] = '';
                }

                if (isset($this->request->server['HTTP_USER_AGENT'])) {
                    $order_data['user_agent'] = $this->request->server['HTTP_USER_AGENT'];
                } else {
                    $order_data['user_agent'] = '';
                }

                if (isset($this->request->server['HTTP_ACCEPT_LANGUAGE'])) {
                    $order_data['accept_language'] = $this->request->server['HTTP_ACCEPT_LANGUAGE'];
                } else {
                    $order_data['accept_language'] = '';
                }


                $this->load->model('tool/upload');

                $data['products'] = array();

                foreach ($this->cart->getProducts() as $product) {
                    $option_data = array();

                    foreach ($product['option'] as $option) {
                        if ($option['type'] != 'file') {
                            $value = $option['value'];
                        } else {
                            $upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

                            if ($upload_info) {
                                $value = $upload_info['name'];
                            } else {
                                $value = '';
                            }
                        }

                        $option_data[] = array(
                                'name'  => $option['name'],
                                'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
                                );
                    }

                    $recurring = '';

                    if ($product['recurring']) {
                        $frequencies = array(
                            'day'        => $this->language->get('text_day'),
                            'week'       => $this->language->get('text_week'),
                            'semi_month' => $this->language->get('text_semi_month'),
                            'month'      => $this->language->get('text_month'),
                            'year'       => $this->language->get('text_year'),
                        );

                        if ($product['recurring']['trial']) {
                            $recurring = sprintf($this->language->get('text_trial_description'), 
                                    $this->currency->format($this->tax->calculate($product['recurring']['trial_price'] * $product['quantity'], $product['tax_class_id'],
                                    $this->config->get('config_tax')), $this->session->data['currency']), $product['recurring']['trial_cycle'],
                                    $frequencies[$product['recurring']['trial_frequency']], $product['recurring']['trial_duration']) . ' ';
                        }

                        if ($product['recurring']['duration']) {
                            $recurring .= sprintf($this->language->get('text_payment_description'),
                                    $this->currency->format($this->tax->calculate($product['recurring']['price'] * $product['quantity'], $product['tax_class_id'],
                                    $this->config->get('config_tax')), $this->session->data['currency']), $product['recurring']['cycle'],
                                    $frequencies[$product['recurring']['frequency']], $product['recurring']['duration']);
                        } else {
                            $recurring .= sprintf($this->language->get('text_payment_cancel'),
                                    $this->currency->format($this->tax->calculate($product['recurring']['price'] * $product['quantity'], $product['tax_class_id'],
                                    $this->config->get('config_tax')), $this->session->data['currency']), $product['recurring']['cycle'], $frequencies[$product['recurring']['frequency']],
                                    $product['recurring']['duration']);
                        }
                    }

                    $data['products'][] = array(
                        'cart_id'    => $product['cart_id'],
                        'product_id' => $product['product_id'],
                        'name'       => $product['name'],
                        'model'      => $product['model'],
                        'option'     => $option_data,
                        'recurring'  => $recurring,
                        'quantity'   => $product['quantity'],
                        'subtract'   => $product['subtract'],
                        'price'      => $this->currency->format($this->tax->calculate($product['price'], $product['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']),
                        'total'      => $this->currency->format($this->tax->calculate($product['price'], $product['tax_class_id'], $this->config->get('config_tax')) * $product['quantity'], $this->session->data['currency']),
                        'href'       => $this->url->link('product/product', 'product_id=' . $product['product_id'])
                        );
                }

                // Gift Voucher
                $data['vouchers'] = array();

                if (!empty($this->session->data['vouchers'])) {
                    foreach ($this->session->data['vouchers'] as $voucher) {
                        $data['vouchers'][] = array(
                            'description' => $voucher['description'],
                            'amount'      => $this->currency->format($voucher['amount'], $this->session->data['currency'])
                            );
                    }
                }

                $data['totals'] = array();

                foreach ($order_data['totals'] as $total) {
                    $data['totals'][] = array(
                        'title' => $total['title'],
                        'text'  => $this->currency->format($total['value'], $this->session->data['currency'])
                        );
                }

                $this->load->model('checkout/order');

                $this->session->data['order_id'] = $this->model_checkout_order->addOrder($order_data);
                // $this->model_checkout_order->addOrderHistory( $this->session->data['order_id'], 0, $comment, false, false);
                if (isset($_SERVER['HTTPS'])) { if ($_SERVER['HTTPS']=="on") $isCurrentUrlHttps = 1; else $isCurrentUrlHttps = 0; } else $isCurrentUrlHttps = 0;
                $json["cartId"] = $cartId;
                $json["reference"] = $this->session->data["order_id"];
                $locale = $this->language->get('code');
                if ($locale=="") $locale = "en";  // english GUI if locale is not set because of some config issue
                $json["locale"] = $locale;
                $json["transactionUrl"]["returnUrl"]["url"]       = ($isCurrentUrlHttps ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=extension/payment/make_commerce/callback';
                $json["transactionUrl"]["returnUrl"]["method"]    = "POST";
                $json["transactionUrl"]["cancelUrl"]["url"]       = ($isCurrentUrlHttps ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=extension/payment/make_commerce/callback';
                $json["transactionUrl"]["cancelUrl"]["method"]    = "POST";
                $json["transactionUrl"]["notificationUrl"]["url"] = ($isCurrentUrlHttps ? HTTPS_SERVER : HTTP_SERVER) . 'index.php?route=extension/payment/make_commerce/callback';
                $json["transactionUrl"]["notificationUrl"]["method"] = "POST";
                unset($this->session->data["shipping_method"]);
                @ob_clean();
                return addcslashes(json_encode($json, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES), '/');
            } else {
                error_log("makeOrder error: $error");
                return "Error: $error";
            }
        } else {
            error_log("Cart is not OK");
            return 0;
        }
    }
}
?>
