 jQuery(function($) {

    var makeCommerceMethodBox  = $('.payment-box.payment-method-makecommerce');
    var countryPickerContainer = $('.makecommerce-country-picker-countries');
    var mkPaymentMethodInput   = makeCommerceMethodBox.find('#mk-payment-method');
    var selectedCountry        = countryPickerContainer.find('input[name="makecommerce_country_picker"]:checked');

    /**
     * Shows payment options that are in the selected country.
     * 
     * @param jQuery seletedInput 
     */
    function setSelectedMakeCommerceCountry(seletedInput) {                               
        var countryIsoCode = seletedInput.val();
        var countryPicker  = $('.makecommerce-picker-country');
        var countryInputId = seletedInput.attr('id');
        var countryLabel   = countryPickerContainer.find('label[for="' + countryInputId + '"]');

        countryPickerContainer.find('label').removeClass('selected');
        makeCommerceMethodBox.find('.makecommerce-banklink-picker').removeClass('selected');
        mkPaymentMethodInput.val('');

        countryPicker.hide();

        if (countryLabel.length) {
            countryLabel.addClass('selected');
            $('.makecommerce-picker-country[data-country-iso="' + countryIsoCode + '"]').show();
        }
    }

    /**
     * Sets selected MakeCommerce payment option.
     * 
     * @param jQuery selectedPaymenty 
     */
    function setSelectedPaymentOption(selectedPaymenty) {                   
        var selectedType = (selectedPaymenty === false ? '' : selectedPaymenty.attr('data-method'));

        mkPaymentMethodInput.val(selectedType);

        $.ajax({
            url: 'index.php?route=extension/payment/make_commerce/set',
            type: 'post',
            data: {
                selected_method: selectedType
            },
            dataType: 'json',
            beforeSend: function() {
                
            },
            success: function(json) {
                // d quickcheckout 
                if (typeof window.qc !== 'undefined') {
                    $('#payment_method_list input#make_commerce').change();
                }
            },
            error: function(xhr, ajaxOptions, thrownError) {
                alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
            }
        });

        makeCommerceMethodBox.find('.makecommerce-banklink-picker').removeClass('selected');

        if (selectedPaymenty !== false)
            selectedPaymenty.addClass('selected');
    }                

    if (countryPickerContainer.length)
        setSelectedMakeCommerceCountry(selectedCountry);

    if (window.is_mk_default_method == '1')
        $('input[name="payment_method"][value="make_commerce"]').click();

    /* Add event listeners */
    makeCommerceMethodBox.find('.makecommerce-banklink-picker').on('click', function() {
        setSelectedPaymentOption($(this));
    });

    $('input[name="makecommerce_country_picker"]').on('change', function() {
        setSelectedMakeCommerceCountry($(this));
        setSelectedPaymentOption(false);
    });

    if ($('input[name="payment_method"]').length === 1 || 
        $('input[name="payment_method"][value="make_commerce"]').is(':checked')) {
        makeCommerceMethodBox.css('display', 'block');
    }
        

    $('input[name="payment_method"]').on('change', function() {
        if ($(this).val() == 'make_commerce')
            makeCommerceMethodBox.show();
        else
            makeCommerceMethodBox.hide();
    });

});