<?php
require 'vendor/autoload.php';

use Cronp\Schedule\Schedule;
use Cronp\Scheduler;
use Cronp\Executer\BackgroundExecExecuter;
use Cronp\Persist\StreamPersist;

$scheduler = new Scheduler(
    new StreamPersist(fopen('schedules.cache', 'a+')),
    new BackgroundExecExecuter()
);

if ( ! $scheduler->count()) {
	$scriptPath = realpath(dirname(__FILE__) . '/url_requests.php');

    $scheduler->addSchedule(new Schedule($scriptPath, 86400));
}

$scheduler->execute();